<?php
namespace Planejamento\Repositories;

class Planrecprod extends \Doctrine\ORM\EntityRepository
{
    public function consisteEstoque($cdfilial,$nrplanprod,$cdprodacabado,$cdfiliagreg,
            $cdservfiliagreg,$dtconsumo,$tdtconsumo, $nrorg)
    {
        $sql = <<<SQL
SELECT DISTINCT PROD.CDPRODUTO || ' - ' || PROD.NMPRODUTO AS NMPRODUTO
FROM (SELECT :P_CDFILIAL AS CDFILIAL, R.CDPRODUTO, P.DTPRODUCAO, SUM(QTPRODRECEPRAT) AS QTREQUERIDA
      FROM PLANRECPROD R
           INNER JOIN PLANPRODUCAO P ON (P.CDFILIAL  = R.CDFILIAL AND
                                        P.NRPLANPROD = R.NRPLANPROD)
      WHERE R.CDFILIAL       = :P_CDFILIAL
        AND R.NRPLANPROD     = :P_NRPLANPROD
        AND R.CDPRODACABADO  = :P_CDPRODACABADO
        AND ((:P_CDFILIAGREG = 'T') OR (R.CDFILIAGREG = :P_CDFILIAGREG))
        AND ((:P_CDSERVFILIAGREG = 'T') OR (R.CDSERVFILIAGREG = :P_CDSERVFILIAGREG))
        AND ((:P_TDTCONSUMO  = 'T') OR (R.DTCONSUMO = :P_DTCONSUMO))
      GROUP BY :P_CDFILIAL, R.CDPRODUTO, P.DTPRODUCAO) R
      INNER JOIN PRODUTO PROD ON (R.CDPRODUTO = PROD.CDPRODUTO)
INNER JOIN POSESTDIA P ON P.CDFILIAL   = R.CDFILIAL AND
                          P.CDPRODUTO  = R.CDPRODUTO AND
                          P.DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                            FROM POSESTDIA
                                           WHERE (CDFILIAL     = :P_CDFILIAL)
                                             AND (CDALMOXARIFE = ' ')
                                             AND (CDLOCALESTOQ = ' ')
                                             AND (NRLOTEESTQ   = ' ')
                                             AND (NRSUBLOTE    = ' ')
                                             AND (CDPRODUTO    = PROD.CDPRODESTO)
                                             AND (DTPOSIESTQ  <= R.DTPRODUCAO))
WHERE (P.CDFILIAL IS NULL OR (P.QTESTOQDIA - R.QTREQUERIDA) < 0 )
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_NRPLANPROD' => $nrplanprod,
            'P_CDPRODACABADO' => $cdprodacabado,
            'P_CDFILIAGREG' => $cdfiliagreg,
            'P_CDSERVFILIAGREG' => $cdservfiliagreg,
            'P_DTCONSUMO' => $dtconsumo,
            'P_TDTCONSUMO' => $tdtconsumo,
            'P_NRORG' => $nrorg
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql,
                $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function BuscaLimiteSeguranca($nrorg, $data)
    {
        $sql = <<<SQL
SELECT TO_DATE(:P_DATA) + (NVL(MAX(QTLIMSEG),0)) QTLIMSEG
  FROM (SELECT MAX(LPAD(QTLIMSEGFILI,3,0)) QTLIMSEG
          FROM RECEFILI
         WHERE NRORG = :P_NRORG
        UNION ALL
        SELECT MAX(LPAD(QTLIMSEGSERV,3,0)) QTLIMSEG
          FROM RECESERV
         WHERE NRORG = :P_NRORG
        UNION ALL
        SELECT MAX(LPAD(QTLIMSEGPADR,3,0)) QTLIMSEG
          FROM RECEPADR
         WHERE NRORG = :P_NRORG)
SQL;
        $params = array(
            'P_DATA'  => $data,
            'P_NRORG' => $nrorg
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql,
                $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function buscaValorUnitario($nrorg, $cdfilial, $cdproduto, $dtconsumo)
    {
        $sql = <<<SQL
SELECT ROUND(NVL(CUSTO_PRODUTO(:P_CDFILIAL, :P_CDPRODUTO, DECODE(PF.CDTIPCUSTEST,
'', '03', PF.CDTIPCUSTEST), :P_DTCONSUMO, SYSDATE), 0),5) AS VRUNITRECEPRAT
  FROM PARAMFILIAL PF
 WHERE CDFILIAL = :P_CDFILIAL
   AND PF.NRORG = :P_NRORG
SQL;
        $params = array(
            'P_CDFILIAL'  => $cdfilial,
            'P_CDPRODUTO' => $cdproduto,
            'P_DTCONSUMO' => $dtconsumo,
            'P_NRORG'     => $nrorg
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql,
                $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}