function Timeline($scope, $interval, ApplicationContext, templateManager, MessageService) {
    var sf = $scope;
    
    window.addEventListener("resize", () => $scope.calcSpaceItens(), false);
    
    $scope.$watch(() => $scope.widget.dataSource.data, () => {
        initStripe();
        addQtComesticar();
    }, true);
    
   function initStripe(){
        var data = $scope.widget.dataSource.data;
        if(data.length > 0){
            let initHour = formatHour("0000");
            let finHour = formatHour("0000");
            let pass = '01.00';
            $scope.hoursStripe = [];
            
            if(data.length > 0){
                initHour = formatHour(data[0].HRINICATEN);
                finHour =  formatHour(data[0].HRFINASERV);    
            }
            
            for(let i=0; initHour.format('HH:mm') <= finHour.format('HH:mm'); i++){
                let modifyHour = moment(initHour);
                $scope.hoursStripe.push(modifyHour);
                initHour.add(parseInt(pass.substring(0,2)), 'hours');
                initHour.add(parseInt(pass.substring(3,5)), 'minutes');
            }
            intervalStrip();
            calcDashedIni(formatHour(data[0].HRINICSERV));
        }else{
            MessageService.showMessageByCode("MSG_INICIAPAINELCADENCI", null, Constants.errorMessage);
        }
    }
    
    $scope.calcSpaceItens = function(){
        if(document.querySelector('.stripe-itens') != null){
            let largTemp = document.getElementsByClassName('stripe-itens').length * document.querySelector('.stripe-itens').offsetWidth;
            document.querySelector('.strip-space').style.width = (largTemp - (document.querySelector('.stripe-itens').offsetWidth)) + 'px';
        }
    };
    
    function calcDashedIni(horaIniServ){
        let horaInicio = $scope.hoursStripe[0];
        let horaFinal = $scope.hoursStripe.slice(-1)[0];
        let percent = ((horaIniServ.valueOf() - horaInicio.valueOf()) * 100) / (horaFinal.valueOf() - horaInicio.valueOf());
        $(".dashed-strip-inicial").css("left", percent.toFixed(1) + '%');
        $(".comensais").css("left", percent.toFixed(1) + '%');
        $(".efetivos").css("left", percent.toFixed(1) + '%');
    }
    
    function formatHour(hour){
      if(hour){
          hour = hour.replace(':', '');
          return moment().hours(hour.substr(0,2)).minutes(hour.substr(2,2));
      }
    }
    
    // Calcula o progresso da faixa de tempo por porcentagem.
    function progressoStrip(horaInicio, horaFinal){
        let tempoAtual = moment().valueOf();
        let percent = ((tempoAtual - horaInicio.valueOf()) * 100) / (horaFinal.valueOf() - horaInicio.valueOf());
        if(percent >= 100) percent = 100;
        if(percent <= 0) percent = 0;
        return Math.round(percent);
    }
    
    // Cria um intervalo que atualiza o progesso da faixa de acordo com o tempo atual.
    function intervalStrip(){
        let horaInicio = $scope.hoursStripe[0];
        let horaFinal = $scope.hoursStripe.slice(-1)[0];
        let progresso = 0;
        let interval = $interval(function(){
            if(horaInicio != null && horaFinal != null){
                progresso = progressoStrip(horaInicio, horaFinal);
                $(".strip").css("left", progresso + '%');
            } 
            
            if(progresso >= 100) $interval.cancel(interval);
        }, 1000);
    }
    
    function addQtComesticar(){
        if($scope.widget.dataSource.data.length == 0) $(".comensais").css("display", "none"); 
        else{
            let dataQtComestica = templateManager.container.getWidget('timeline').dataSource.data;
            let comensal = 0;
            if(dataQtComestica[0] != undefined) comensal = dataQtComestica[0].QTCOMESTICAR;
            $scope.comensais = comensal + ' Comensais Estimados';    
        }
    }
}