package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class EmbalagemPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");

    By opcaoTelaEmbalagem = By.xpath("//span[text() = 'Embalagem']");

    By botaoAdicionar = By.xpath("//footer[@id=\"footer\"]//li[@zh-ripple-effect]");

    By campoCodigo = By.id("CDCONTAINER");
    By campoEmbalagem = By.id("NMCONTAINER");
    By campoTipo = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By tipoEnvase = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//li[text() = 'Envase']");
    By tipoTransporte = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//li[text() = 'Transporte']");
    By tipoAmbos = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//li[text() = 'Ambos']");
    By campoProposito = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By propositoColetivo = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//li[text() = 'Coletivo']");
    By propositoIndividual = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//li[text() = 'Individual']");
    By campoCategoria = By.id("NMCATEMBALAG");
    By categoriaPrimaria = By.xpath("//div[@data-zh-id=\"12378797141471844620707\"]//span[text() = '00001 | PRIMÁRIA']");
    By categoriaSecundaria = By.xpath("//div[@data-zh-id=\"12378797141471844620707\"]//span[text() = '00002 | SECUNDÁRIA']");
    By botaoUnidade = By.xpath("//div[@id=\"SGUNIDADE\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By unidadeMililitro = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'MILILITRO']");
    By unidadeLata = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'LATA']");
    By campoCapacidade = By.id("QTCONTAINER");

    By botaoSalvar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-left\"]");

    By checkBoxEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By nomeEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By tipoEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"IDEMBALAGEM\"]/span");
    By propositoEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"IDPROPOSITO\"]/span");
    By capacidadeEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"QTCONTAINER\"]/span");
    By categoriaEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"NMCATEMBALAG\"]/span");
    By unidadeEmbalagem = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[9]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"12378797142511755336700\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioEmbalagem = By.xpath("//div[@data-zh-id=\"12378797144240840199701\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCapacidade = By.xpath("//div[@data-zh-id=\"12378797143427157509710\"]//div[@class=\"zh-validation\"]/span");

    By checkBoxEmbalagemPlastico = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[4]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");

    By embalagemParaEdicao = By.xpath("//div[@data-zh-field-name=\"CDCONTAINER\"]//span[text() = '0050']");
    By botaoEditar = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"12378797142006480426654\"]");
    By botaoExcluir = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"1237879714379788563652\"]");

    By mensagemExcluirSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlertaExclusao = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By botaoSimDeletar = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Embalagem");
        click(opcaoTelaEmbalagem);
    }

    public void adicionar(boolean addCapacidade) {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "50");
        sendKeys(campoEmbalagem, "PANELA");
        clicarCampoSelecionarValor(campoTipo, tipoAmbos);
        clicarCampoSelecionarValor(campoProposito, propositoIndividual);
        clicarCampoSelecionarValor(campoCategoria, categoriaPrimaria);
        click(botaoUnidade);
        sendKeys(campoProcurar, "MILILITRO");
        click(unidadeMililitro);
        if (addCapacidade) {
            sendKeys(campoCapacidade, "5");
        }
        click(botaoSalvar);
        tempo();
        click(botaoVoltar);

        tempo();
        String nome = getText(nomeEmbalagem);
        String tipo = getText(tipoEmbalagem);
        String proposito = getText(propositoEmbalagem);
        String categoria = getText(categoriaEmbalagem);
        String unidade = getText(unidadeEmbalagem);

        if (addCapacidade) {
            String capacidade = getText(capacidadeEmbalagem);
            Assert.assertEquals(capacidade, "5,00000", "Verificação da capacidade");
        } else {
            String capacidade = getText(capacidadeEmbalagem);
            Assert.assertEquals(capacidade, "", "Verificação da capacidade");
        }

        Assert.assertEquals(nome, "PANELA", "Verificação do nome");
        Assert.assertEquals(tipo, "Ambos", "Verificação do tipo");
        Assert.assertEquals(proposito, "Individual", "Verificação do propósito");
        Assert.assertEquals(categoria, "PRIMÁRIA", "Verificação da categoria");
        Assert.assertEquals(unidade, "ML", "Verificação da unidade");
    }

    public void editar() {
        tempo();
        tempo();
        click(nomeEmbalagem);
        click(botaoEditar);
        clearAndSendKeys(campoEmbalagem, "PANELAS");
        clicarCampoSelecionarValor(campoCategoria, categoriaSecundaria);
        click(botaoUnidade);
        click(botaoUnidade);
        sendKeys(campoProcurar, "LATA");
        click(unidadeLata);
        clear(campoCapacidade);
        sendKeys(campoCapacidade, "7");
        click(botaoSalvar);
        tempo();
        click(botaoVoltar);

        tempo();
        String nome = getText(nomeEmbalagem);
        String categoria = getText(categoriaEmbalagem);
        String capacidade = getText(capacidadeEmbalagem);
        String unidade = getText(unidadeEmbalagem);

        Assert.assertEquals(nome, "PANELAS", "Verificação do nome");
        Assert.assertEquals(categoria, "SECUNDÁRIA", "Verificação da categoria");
        Assert.assertEquals(capacidade, "7,00000", "Verificação da capacidade");
        Assert.assertEquals(unidade, "LA", "Verificação da unidade");
    }

    public void excluir() {
        tempo();
        click(checkBoxEmbalagem);
        tempo();
        click(botaoExcluir);
        tempo();
        String mensagemAlerta = getText(mensagemAlertaExclusao);
        Assert.assertEquals(mensagemAlerta, "Deletar o(s) registro(s)?", "Verificação da mensagem de exclusão da embalagem");
        click(botaoSimDeletar);

        String mensagemExcluidoSucesso = getText(mensagemExcluirSucesso);
        Assert.assertEquals(mensagemExcluidoSucesso, "Excluído com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão da embalagem");
    }

    public void camposObrigatorios() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrada nos campos
        String codigo = getText(mensagemObrigatorioCodigo);
        String embalagem = getText(mensagemObrigatorioEmbalagem);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo código");
        Assert.assertEquals(embalagem, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo embalagem");
    }

    public void adicionarCodigoExistente() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoEmbalagem, "PANELA");
        clicarCampoSelecionarValor(campoTipo, tipoAmbos);
        clicarCampoSelecionarValor(campoProposito, propositoIndividual);
        clicarCampoSelecionarValor(campoCategoria, categoriaPrimaria);
        click(botaoUnidade);
        sendKeys(campoProcurar, "MILILITRO");
        click(unidadeMililitro);
        sendKeys(campoCapacidade, "5");
        click(botaoSalvar);

        //mensagem alerta de código já existente
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentar adicionar um código já existente");
        click(botaoOk);
    }

    public void tentarExcluirEmbaComRegistrosFilhos() {
        click(checkBoxEmbalagemPlastico);
        click(botaoExcluir);
        tempo();
        String mensagemAlerta = getText(mensagemAlertaExclusao);
        Assert.assertEquals(mensagemAlerta, "Deletar o(s) registro(s)?", "Verificação da mensagem de exclusão da embalagem");
        click(botaoSimDeletar);

        mensagemAlerta = getText(mensagemAlertaExclusao);
        String mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta informando que não é possível excluir a embalagem, pois a mesma possuí registros filhos");
        click(botaoOk);
    }

    public void verificarOpcaoesTipoEProposito() {
        click(botaoAdicionar);
        click(campoTipo);

        boolean existeTipoEnvase = returnIfElementExists(tipoEnvase);
        boolean existeTipoTransporte = returnIfElementExists(tipoTransporte);
        boolean existeTipoAmbos = returnIfElementExists(tipoAmbos);
        Assert.assertEquals(existeTipoEnvase, true, "Verificar se existe o tipo envase nas opções de tipo da embalagem");
        Assert.assertEquals(existeTipoTransporte, true, "Verificar se existe o tipo transporte nas opções de tipo da embalagem");
        Assert.assertEquals(existeTipoAmbos, true, "Verificar se existe o tipo ambos nas opções de tipo da embalagem");

        click(campoProposito);
        boolean existePropositoColetivo = returnIfElementExists(propositoColetivo);
        boolean existePropositoIndividual = returnIfElementExists(propositoIndividual);
        Assert.assertEquals(existePropositoColetivo, true, "Verificar se existe o propósito coletivo nas opções de propósito da embalagem");
        Assert.assertEquals(existePropositoIndividual, true, "Verificar se existe o propósito individual nas opções de propósito da embalagem");
    }

    public void zerarCapacidadePeloInLine() {
        tempo();
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(capacidadeEmbalagem)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

        click(botaoSalvar);
        tempo();
        String capacidade = getText(capacidadeEmbalagem);
        Assert.assertEquals(capacidade, "", "Verificação da capacidade após ser editada e adiconado o valor 0");
    }

    public void editarCapacidadepeloInLine() {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(capacidadeEmbalagem)).click().build().perform();
        tempo();
        actions.sendKeys("5,6").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

        click(botaoSalvar);
        tempo();
        String capacidade = getText(capacidadeEmbalagem);
        Assert.assertEquals(capacidade, "5,60000", "Verificação da capacidade após ser editada pelo inLine");
    }

}
