package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class SubstituicaoPratoCardapioPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaCardapio = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[2]/ul/li[1]/span/span[3]");
    By clicaSubstituicao = By.xpath("//ul[@class = 'sub-menu']//span[@class = 'menu-link']//span[contains(text(),'Substituição de Pratos do Cardapio')]");
    By telaSubstituicao = By.xpath("//div[text() = 'Substituição de Pratos do Cardapio']");
    By agrupamentoUnidade = By.xpath("//span[@zh-icon='no-border search']");
    By campoFilial = By.xpath("//div[@id = 'NMFILIAL']");
    By todasUnidades = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]");
    By unidadeDois = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By btnOk = By.xpath("//div[@class = 'zh-footer-right']//span[text() = 'Ok']");
    By demarcaTodosGrupoServico = By.xpath("//div[@data-zh-id='2144890823619351231373']//span[@zh-icon='checked no-border']");
    By campoGrupoServico = By.xpath("//div[@id = 'NMGRUPSERV']");
    By marcaGrupo = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By limpaData = By.xpath("//div[@id = 'INTERVAL']//span[@zh-icon='no-border close-x']");
    By dtInicial = By.xpath("//*[@id = 'INTERVAL_START']");
    By dtFinal = By.xpath("//*[@id = 'INTERVAL_END']");
    By campoServico = By.xpath("//div[@id = 'DSSERVICO']");
    By marcaTodosServico = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By radioSubstituirPrato = By.xpath("//label[@for = 'radio-RADIO_GROUP-SUBSTITUIRPRATO']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By radioAlterarConsumo = By.xpath("//label[@for = 'radio-RADIO_GROUP-ALTERARCONSUMO']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By buscaPratoInicial = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMPRATOATUAL zh-text-align-left']//span[@zh-icon = 'no-border search']");
    By lupaBusca = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaCampoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaPrato = By.xpath("//div[@class = 'tr cell1']");
    By buscaPratoSubstituto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMPRATOSUBST zh-text-align-left']//span[@zh-icon = 'no-border search']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By btnSim = By.xpath("//span[text() = 'Sim']");
    By botaoOk = By.xpath("//button[@class = 'zh-alert-button']//span[text() = 'OK']");
    By limpaPrato = By.xpath("//div[@id = 'NMPRATOATUAL']//span[@zh-icon= 'no-border close-x']");
    By campoValor = By.xpath("//input[@id = 'PLATE_VALUE']");
    By radioPercentualConsumo = By.xpath("//label[@for = 'radio-CHANGE_CONSUMPTION-PERCENTUALCONSUMO']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By radioNumeroComensais = By.xpath("//label[@for = 'radio-CHANGE_CONSUMPTION-NUMEROCOMENSAIS']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By clicaPrato = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");

    public void acessaSubstituicaoPratoCardapio(){
        waitForElement(usernameLoginInfoTextArea);
        click(clicaMenu);
        click(clicaPlanejamento);
        click(clicaCardapio);
        click(clicaSubstituicao);
        tempo();
        waitForElement(telaSubstituicao);
        tempo();
    }

    public void alterarPrato(String DTINICIAL, String DTFINAL, String NMPRATO, String NMPRATOTROCA){
        click(campoFilial);
        tempo();
        click(unidadeDois);
        click(btnOk);
        tempo();
        click(limpaData);
        tempo();
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);
        click(campoServico);
        tempo();
        click(marcaTodosServico);
        tempo();
        click(btnOk);
        tempo();
        click(buscaPratoInicial);
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATO);
        tempo();
        click(selecionaPrato);
        tempo();
        click(buscaPratoSubstituto);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATOTROCA);
        tempo();
        click(selecionaPrato);
        tempo();
        click(btnConfirmar);
        tempo();
        click(btnSim);
        tempo();
        click(botaoOk);
        tempo();


    }

    public void alteraConsumo(String NMPRATO, String VALOR){
        click(radioAlterarConsumo);
        click(limpaPrato);
        click(buscaPratoInicial);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca, NMPRATO);
        tempo();
        click(selecionaPrato);
        tempo();
        click(campoValor);
        sendKeys(campoValor,VALOR);
        click(btnConfirmar);


    }

    public void validaPratos(String CDAGRUPAMENTO,String DTINICIAL, String DTFINAL, String NMPRATO, String NMPRATOTROCA, String NMPRATO_1, String NMPRATOTROCA_1 ){
        click(agrupamentoUnidade);
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDAGRUPAMENTO);
        tempo();
        click(selecionaBusca);
        tempo();
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);
        tempo();
        click(campoServico);
        tempo();
        click(marcaTodosServico);
        click(marcaTodosServico);
        tempo();
        click(btnOk);
        tempo();
        click(buscaPratoInicial);
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATO);
        tempo();
        click(clicaPrato);
        tempo();
        click(buscaPratoSubstituto);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATOTROCA);
        tempo();
        click(clicaPrato);
        tempo();
        click(btnConfirmar);
        tempo();
        click(botaoOk);
        tempo();
        click(limpaPrato);
        tempo();
        click(buscaPratoInicial);
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATO_1);
        tempo();
        click(selecionaPrato);
        tempo();
        click(buscaPratoSubstituto);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATOTROCA_1);
        tempo();
        click(selecionaPrato);
        tempo();
        click(btnConfirmar);
        tempo();
        click(botaoOk);
        tempo();

    }

    public void alteraPeriodo(String DTINICIAL, String DTFINAL, String NMPRATO, String NMPRATOTROCA){
        click(demarcaTodosGrupoServico);
        click(campoGrupoServico);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        click(marcaGrupo);
        tempo();
        click(btnOk);
        tempo();
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);
        tempo();
        click(campoServico);
        tempo();
        click(marcaTodosServico);
        tempo();
        click(btnOk);
        tempo();
        click(buscaPratoInicial);
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATO);
        tempo();
        click(clicaPrato);
        tempo();
        click(buscaPratoSubstituto);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,NMPRATOTROCA);
        tempo();
        click(clicaPrato);
        tempo();
        click(btnConfirmar);
        tempo();
        click(btnSim);
        tempo();


    }









}
