package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.ApresentacaoProdutoFlows;
import com.javaseleniumtemplate.pages.ApresentacaoProdutoPage;
import org.testng.annotations.Test;

public class ApresentacaoProdutoTests extends TestBase {

    ApresentacaoProdutoPage apresentacaoProdutoPage;
    ApresentacaoProdutoFlows apresentacaoProdutoFlows;
    LoginFlows loginFlows;

    //adicionar uma apresentação ao produto CHINA OFFICINALLIS (CASCA)
    //editar a quantidade da apresentação adicionada
    //excluir apresentação
    //gerar relatório
    @Test
    public void apresentacao() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.selecionarProduto();
        apresentacaoProdutoPage.adicionarApresentacao();
        apresentacaoProdutoPage.editarQuantidade();
        apresentacaoProdutoPage.excluirApresentacao();
        apresentacaoProdutoPage.refresh();
        apresentacaoProdutoPage.gerarRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar campos obrigatórios da tela de geração do relatório
    //verificar campos obrigatórios da tela de adicionar apresentação
    //verificar valor obrigatório do campo quantidade no momento da edição da apresentação. O valor da edição deve ser maior que 0
    @Test
    public void relatorio() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.campoObrigatorioRelatorio();
        apresentacaoProdutoPage.refresh();
        apresentacaoProdutoPage.selecionarProduto();
        apresentacaoProdutoPage.camposObrigatoriosAddApresentacao();
        apresentacaoProdutoPage.valorObrigatorioEdicaoQuant();
        apresentacaoProdutoPage.excluirApresentacao();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
