package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RelacaoPratoXEmbalagemFlows;
import com.javaseleniumtemplate.pages.RelacaoPratoXEmbalagemPage;
import org.testng.annotations.Test;

public class RelacaoPratoXEmbalagemTests extends TestBase {

    RelacaoPratoXEmbalagemPage relacaoPratoXEmbalagemPage;
    RelacaoPratoXEmbalagemFlows relacaoPratoXEmbalagemFlows;
    LoginFlows loginFlows;

    //adicionar a embalagem 'Panela' ao prato 'Feijoada Transportada' e verificar a mesma
    //acessar a aba 'Prato por Embalagem' e verificar se o prato 'Feijoada Transportada' está presente na mesma
    //alterar o valor da quantidade do prato 'Feijoada Transportada', para 7
    //adicionar o prato 'Trota de Chocolate' na embalagem 'Panela'
    //verificar se o prato 'Trota de chocolate' foi adicionado com sucesso através do código, nome, unidade e quantidade
    //acessar a aba 'Embalagem por Prato', acessar o prato 'Torta de Chocolate' e verificar se a emabalagem 'Panela' foi adicionada ao mesmo
    //alterar a quantidade da emabalagem 'Panela' no prato 'Torta de Chocolate'
    //acessar a aba 'Prato por Emabalagem', 'Panela' e verificar se a quantidade do prato 'Torta de Chocolate' também foi alterada
    //acessar a aba 'Embalagem por Prato' e verificar se a quantidade da emabalagem 'Panela' também foi alterada para o valor 7, no prato 'Feijoada Transportada'
    //remover a embalagem 'Panela' na tela do prato 'Feijoada Transportada'
    //acessar a aba 'Prato por Embalagem' e remover o prato 'Torta de Chocolate' na tela da embalagem 'Panela'
    @Test
    public void adicionarVerificarERecemoverRegistros() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.adicionarEmbalagemPrato();
        relacaoPratoXEmbalagemPage.verificarEmbalagem();
        relacaoPratoXEmbalagemPage.verificarEmbalagemAddNaAbaPratoEmbalagem();
        relacaoPratoXEmbalagemPage.alterarQuantidadePrato();
        relacaoPratoXEmbalagemPage.adicionarPratoEmbalagem();
        relacaoPratoXEmbalagemPage.verificarSegundoPratoAddAbaPratoEmbalagem();
        relacaoPratoXEmbalagemPage.verificarSegundaEmbalagemAddAbaEmbalagemPrato();
        relacaoPratoXEmbalagemPage.alterarQuantDaSegundaEmbAdd();
        relacaoPratoXEmbalagemPage.verificarAlteracaoQuantSegEmbAbaPratoEmbalagem();
        relacaoPratoXEmbalagemPage.verificarAlteracaoDaQuantNaAbaEmbPorPrat();
        relacaoPratoXEmbalagemPage.removerEmbalagemPratoFeijada();
        relacaoPratoXEmbalagemPage.removerPratoTortaChocolate();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //adicionar a embalagem 'Panela' ao prato 'Feijoada Transportada'
    //tentar adicionar novamente a embalagem 'Panela' ao prato 'Feijoada Transportada' e verificar se é exibida a mensagem informando que o registro já existe
    //adicionar uma embalagem diferente (Marmitéx) ao prato 'Feijoada Transportada' e verificar se a mesma foi adicionada com sucesso
    //excluir as duas embalagens (Panela e Marmitéx) do prato 'Feijoada Transportada'
    //acessar a aba 'Embalagem por Prato' e adicionar o prato 'Torda de Chocolate' à embalagem 'Panela'
    //tentar adicionar novamente o prato 'Torda de Chocolate' à embalagem 'Panela' e verificar se é exbida a mensagem informando que o registro já existe
    //remover o prato 'Torta de Chocolate' que foi adicionado com sucesso
    @Test
    public void tentarAddRegistrosJaExistentes() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.adicionarEmbalagemPrato();
        relacaoPratoXEmbalagemPage.tentarAddEmbalagemJaAddAoPratoFeijoadaTransportada();
        relacaoPratoXEmbalagemPage.addPratoTortaChocolatePratoEmbalagem();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
